<?xml version="1.0" encoding="UTF-8" ?>
<beans xmlns="http://www.springframework.org/schema/beans"
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xmlns:util="http://www.springframework.org/schema/util"
       xmlns:aop="http://www.springframework.org/schema/aop"
       xmlns:tx="http://www.springframework.org/schema/tx"
       xsi:schemaLocation="
http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.5.xsd
http://www.springframework.org/schema/util http://www.springframework.org/schema/util/spring-util-2.5.xsd
http://www.springframework.org/schema/aop http://www.springframework.org/schema/aop/spring-aop-2.5.xsd
http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-2.5.xsd">

<!--
    - データアクセス層のアプリケーションコンテキスト定義。
	- "applicationContext.xml"で定義されているビジネス層のオブジェクトからアクセスされる。
	- (web.xmlの"contextConfigLocation"参照)。
	-->

  <!-- ========================= リソース定義 ========================= -->
  <!-- "combined database(?)"を参照するための、ローカルな Apache Commons DBCP DataSource -->
  <!-- (別の手段については dataAccessContext-jta.xml 参照) -->
  <!-- プレースホルダ ${...}は jdbc.properties によって解決される -->
  <!-- プレースホルダのConfigurerの設定は、applicationContext.xml内にある -->

  <!-- データソースのBean定義 -->
  <!-- JNDIの場合 -->
  <!-- 「/webapps/META-INF/context.xml」を自端末の環境に合った値に書き換える -->

  <bean id="dataSource"
        class="org.springframework.jndi.JndiObjectFactoryBean">
    <property name="jndiName" value="java:comp/env/jdbc/TerasolunaFunctionDataSource" />
  </bean>

  <!-- JNDIを使用しない場合 -->
  <!-- 「/webapps/WEB-INF/jdbc.properties」を自端末の環境に合った値に書き換える -->
  <!--   
  <bean id="dataSource" class="org.apache.commons.dbcp.BasicDataSource" destroy-method="close">
	<property name="driverClassName" value="${jdbc.driverClassName}"/>
	<property name="url" value="${jdbc.url}"/>
	<property name="username" value="${jdbc.username}"/>
	<property name="password" value="${jdbc.password}"/>
  </bean>
  -->

  <!-- 単一のJDBCデータソース向けのトランザクションマネージャ -->
  <bean id="transactionManager" 
      class="org.springframework.jdbc.datasource.DataSourceTransactionManager">
    <property name="dataSource" ref="dataSource"/>
  </bean>

  <!-- iBATIS データベース層のためのSQlMapの設定 -->
  <bean id="sqlMapClient" class="org.springframework.orm.ibatis.SqlMapClientFactoryBean">
    <property name="configLocation" value="WEB-INF/sqlMapConfig.xml"/>
	<property name="dataSource" ref="dataSource"/>
  </bean>
	
  <!-- リソースバンドル（DB利用）用DAOの設定 -->
  <bean id="DBMessageResourceDAO" 
      class="jp.terasoluna.fw.message.DBMessageResourceDAOImpl">
    <property name="dataSource" ref="dataSource"/>
    <property name="tableName"      value="DBMESSAGES"/>
    <property name="codeColumn"     value="CODE"/>
    <property name="messageColumn"  value="MESSAGE"/>                        
    <property name="languageColumn" value="LANGUAGES"/>
    <property name="countryColumn"  value="CONTRY"/>
    <property name="variantColumn"  value="VARIANT"/>                    
    
  </bean>
	
	
  <!-- ===================== DAO定義: IBATIS実装 ===================== -->
  <!-- 照会系のDAO -->
  <bean id="queryDAO" 
      class="jp.terasoluna.fw.dao.ibatis.QueryDAOiBatisImpl">
	<property name="sqlMapClient" ref="sqlMapClient"/>
  </bean>
  
  <!-- 更新系のDAO -->
  <bean id="updateDAO" 
      class="jp.terasoluna.fw.dao.ibatis.UpdateDAOiBatisImpl">
	<property name="sqlMapClient" ref="sqlMapClient"/>
  </bean>
  
  <!-- ストアドプロシジャ用のDAO -->
  <bean id="spDAO" 
      class="jp.terasoluna.fw.dao.ibatis.StoredProcedureDAOiBatisImpl">
	<property name="sqlMapClient" ref="sqlMapClient"/>
  </bean>
  
  <!-- ローハンドラ用のDAO定義 -->
  <bean id="queryRowHandleDAO"
        class="jp.terasoluna.fw.dao.ibatis.QueryRowHandleDAOiBatisImpl">
    <property name="sqlMapClient" ref="sqlMapClient" />
  </bean>
  
  <!-- =============== トランザクションの定義 =============== -->
  <!-- トランザクション定義情報 -->
<!-- 
  <bean id="attrSource" 
      class="org.springframework.transaction.interceptor.NameMatchTransactionAttributeSource">
    <property name="properties">
	  <props>
	    <prop key="insert*">PROPAGATION_REQUIRED,-java.lang.Exception</prop>
		<prop key="update*">PROPAGATION_REQUIRED,-java.lang.Exception</prop>
		<prop key="select*">PROPAGATION_REQUIRED,readOnly,-java.lang.Exception</prop>
	  </props>
    </property>
  </bean>
 -->
  
  <!-- トランザクション処理（インタセプタの定義) -->
<!-- 
  <bean id="transactionInterceptor" 
      class="org.springframework.transaction.interceptor.TransactionInterceptor">
    <property name="transactionManager" ref="transactionManager"/>
    <property name="transactionAttributeSource" ref="attrSource" />
  </bean>
 -->

  <!-- トランザクションインタセプタの設定 -->
  <tx:advice id="transactionInterceptor" >
    <tx:attributes>
      <tx:method name="insert*"  propagation="REQUIRED" rollback-for="java.lang.Exception"/>
      <tx:method name="update*"  propagation="REQUIRED" rollback-for="java.lang.Exception"/>
      <tx:method name="select*"  propagation="REQUIRED" rollback-for="java.lang.Exception" read-only="true"/>
    </tx:attributes>
  </tx:advice>

</beans>
